<template>
<div>
  <a-table :columns="columns" :data-source="items" size="middle" :loading="isLoading">
    <a slot="facePreview" slot-scope="id, row">
      <a-avatar shape="square" :size="50" icon="user" :src="row.profilePhoto" class="bg-blue-light" />
    </a>
    <div slot="operation" slot-scope="id, row">
      <LookupPersonDialog :passenger="row">
        <b-action-button>More detail</b-action-button>
      </LookupPersonDialog>
    </div>
  </a-table>
</div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import BActionButton from '~/components/shared/buttons/ActionButton.vue'
import LookupPersonDialog from '~/components/lookup/LookupPersonDialog.vue'
import { IPassengerItem } from '~/contracts'

const columns = [
  {
    title: 'FACE PREVIEW',
    dataIndex: 'facePreview',
    key: 'facePreview',
    scopedSlots: { customRender: 'facePreview' },
    width: 120,
  },
  {
    title: 'Name',
    dataIndex: 'displayName',
    key: 'displayName',
    width: 300,
  },
  {
    title: 'AREA',
    dataIndex: 'areaName',
    key: 'areaName',
  },
  {
    title: 'UNIT',
    dataIndex: 'unitName',
    key: 'unitName',
  },
  {
    title: '',
    dataIndex: 'operation',
    scopedSlots: { customRender: 'operation' },
    key: 'operation',
    width: 150,
  },
]

export default defineComponent({
  components: { BActionButton, LookupPersonDialog },
  props: {
    isLoading: {
      type: Boolean,
      default: true
    },
    items: {
      type: Array as () => IPassengerItem[],
      required: true
    },
    errrMessage: {
      type: String,
      default: null
    }
  },
  data() {
    return {
      columns,
    }
  },
})
</script>
